D2I_ASN1_NULL(3)

NAME
d2i_ASN1_NULL, i2d_ASN1_NULL - decode and encode an ASN.1 NULL type

SYNOPSIS
#include <openssl/asn1.h>
ASN1_NULL *
d2i_ASN1_NULL(ASN1_NULL **val_out, const unsigned char **der_in, long length);
int
i2d_ASN1_NULL(ASN1_NULL *val_in, unsigned char **der_out);

DESCRIPTION
These functions decode and encode the ASN.1 value NULL of type NULL. For details about the semantics, examples, caveats, and bugs, see ASN1_item_d2i(3).

d2i_ASN1_NULL() verifies that the BER-encoded value at *der_in is NULL and of type NULL. It fails if length is less than 2 or if the first two bytes of *der_in differ from 0x05 and 0x00. In case of success, *der_in is advanced by two bytes and *val_out is set to a specific invalid pointer representing the unique ASN1_NULL object.

i2d_ASN1_NULL() ignores val_in and encodes the ASN.1 value NULL of type NULL using DER. Specifically, it writes the identifier octet for the type NULL, 0x05, followed by the length octet 0x00, and no content or end-of-content octets.

RETURN VALUES
d2i_ASN1_NULL() returns a specific invalid pointer representing the unique ASN1_NULL object or NULL if an error occurs.

i2d_ASN1_NULL() returns 2 if successful or 0 if an error occurs.

SEE ALSO
ASN1_item_d2i(3), ASN1_item_new(3)

STANDARDS
ITU-T Recommendation X.690, also known as ISO/IEC 8825-1: Information technology - ASN.1 encoding rules: Specification of Basic Encoding Rules (BER), Canonical Encoding Rules (CER) and Distinguished Encoding Rules (DER), section 8.8: Encoding of null value

HISTORY
d2i_ASN1_NULL() and i2d_ASN1_NULL() first appeared in OpenSSL 0.9.5 and have been available since OpenBSD 2.7.